cdac.medinfo.sdk.hl7282.baselibs.segments

## Class VAR

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.VAR

- All Implemented Interfaces:
    ISegment

      public class VAR
      extends Segment

  VAR - Variance Segment

  Variance segment contains the data necessary to describe differences that may have occurred at the time when a healthcare event was documented.

  Represents an HL7 VAR message segment. This segment has the following fields:

  VAR-1: Variance Instance ID (EI)Required
  VAR-2: Documented Date/Time (DTM)Required
  VAR-3: Stated Variance Date/Time (DTM)Optional
  VAR-4: Variance Originator (XCN)Optional
  VAR-5: Variance Classification (CWE)Optional
  VAR-6: Variance Description (ST)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `VAR()` Constucts the VAR segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addVarianceDescription(ST objtempVarianceDescription)` Set the Variance Description.
    `void` | `addVarianceDescription(java.lang.String strVarianceDescription)` Set the Variance Description.
    `void` | `addVarianceOriginator(java.lang.String strIDNumber, FN objFamilyName, java.lang.String strGivenName, java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof, java.lang.String strSuffix, java.lang.String strPrefix, CWE objSourceTable, HD objAssigningAuthority, java.lang.String strNameTypeCode, java.lang.String strIdentifierCheckDigit, java.lang.String strCheckDigitScheme, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, CWE objNameContext, java.lang.String strNameAssemblyOrder, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, java.lang.String strProfessionalSuffix, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepratment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Set the Variance Originator.
    `void` | `addVarianceOriginator(XCN objtempvarianceOriginator)` Set the Variance Originator.
    `DTM` | `getDocumentedDateTime()` Retrieves the Documented Date Time.
    `DTM` | `getStatedVarianceDateTime()` Retrieves the Stated Variance Date Time.
    `CWE` | `getVarianceClassification()` Retrieves the Variance Classification.
    `ISingleCollection<ST>` | `getVarianceDescription()` Retrieves the Variance Description.
    `EI` | `getVarianceInstanceID()` Retrieves the Variance Instance ID.
    `ISingleCollection<XCN>` | `getVarianceOriginator()` Retrieves the Variance Originator.
    `void` | `setDocumentedDateTime(DTM objdocumentedDateTime)` Set the Documented Date Time.
    `void` | `setDocumentedDateTime(java.lang.String strTime)` Set the Documented Date Time.
    `void` | `setStatedVarianceDateTime(DTM objstatedVarianceDateTime)` Set the Stated Variance Date Time.
    `void` | `setStatedVarianceDateTime(java.lang.String strTime)` Set the Stated Variance Date Time.
    `void` | `setVarianceClassification(CWE objvarianceClassification)` Set the Variance Classification.
    `void` | `setVarianceClassification(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Variance Classification.
    `void` | `setVarianceDescription(ISingleCollection<ST> objVarianceDescriptionList)` Set the VarianceDescription list.
    `void` | `setVarianceInstanceID(EI objvarianceInstanceID)` Set the Variance Instance ID.
    `void` | `setVarianceInstanceID(java.lang.String strEntityIdentifier, java.lang.String strNamespaceId, java.lang.String strUniversalId, java.lang.String strUniversalIdType)` Set the Variance Instance ID.
    `void` | `setVarianceOriginator(ISingleCollection<XCN> objVarianceOriginatorList)` Set the VarianceOriginator list.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### VAR

          public VAR()

      Constucts the VAR segment.

  - ### Method Detail

    - #### getVarianceInstanceID

          public EI getVarianceInstanceID()

      Retrieves the Variance Instance ID.
      Returns:
        EI - varianceInstanceID

    - #### getDocumentedDateTime

          public DTM getDocumentedDateTime()

      Retrieves the Documented Date Time. This field specify the time stamp that identifies the timed occurrence of the variance documentation.
      Returns:
        DTM - documentedDateTime

    - #### getStatedVarianceDateTime

          public DTM getStatedVarianceDateTime()

      Retrieves the Stated Variance Date Time. This field specify the time stamp that identifies a stated time of the variance which may be different than the time it is documented.
      Returns:
        DTM - statedVarianceDateTime

    - #### getVarianceOriginator

          public ISingleCollection<XCN> getVarianceOriginator()

      Retrieves the Variance Originator.
      Returns:
        ISingleCollection - varianceOriginator

    - #### getVarianceClassification

          public CWE getVarianceClassification()

      Retrieves the Variance Classification.
      Returns:
        CWE - varianceClassification

    - #### getVarianceDescription

          public ISingleCollection<ST> getVarianceDescription()

      Retrieves the Variance Description.
      Returns:
        ISingleCollection - varianceDescription

    - #### setDocumentedDateTime

          public void setDocumentedDateTime(java.lang.String strTime)

      Set the Documented Date Time. This field specify the time stamp that identifies the timed occurrence of the variance documentation.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setDocumentedDateTime

          public void setDocumentedDateTime(DTM objdocumentedDateTime)

      Set the Documented Date Time. This field specify the time stamp that identifies the timed occurrence of the variance documentation.
      Parameters:
        `objdocumentedDateTime` -

    - #### setStatedVarianceDateTime

          public void setStatedVarianceDateTime(java.lang.String strTime)

      Set the Stated Variance Date Time. This field specify the time stamp that identifies a stated time of the variance which may be different than the time it is documented.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setStatedVarianceDateTime

          public void setStatedVarianceDateTime(DTM objstatedVarianceDateTime)

      Set the Stated Variance Date Time. This field specify the time stamp that identifies a stated time of the variance which may be different than the time it is documented.
      Parameters:
        `objstatedVarianceDateTime` -

    - #### setVarianceClassification

          public void setVarianceClassification(java.lang.String strIdentifier,
                                       java.lang.String strText,
                                       java.lang.String strNameOfCodingSystem,
                                       java.lang.String strAlternateIdentifier,
                                       java.lang.String strAlternateText,
                                       java.lang.String strNameOfAlternateCodingSystem,
                                       java.lang.String strCodingSystemVersionID,
                                       java.lang.String strAlternateCodingSystemVersionId,
                                       java.lang.String strOriginalText,
                                       java.lang.String strSecondAlternateIdentifier,
                                       java.lang.String strSecondAlternateText,
                                       java.lang.String strNameofSecondAlternateCodingSystem,
                                       java.lang.String strSecondAlternateCodingSystemVersionID,
                                       java.lang.String strCodingSystemOID,
                                       java.lang.String strValueSetOID,
                                       java.lang.String strValueSetVersionID,
                                       java.lang.String strAlternateCodingSystemOID,
                                       java.lang.String strAlternateValueSetOID,
                                       java.lang.String strAlternateValueSetVersionID,
                                       java.lang.String strSecondAlternateCodingSystemOID,
                                       java.lang.String strSecondAlternateValueSetOID,
                                       java.lang.String strSecondAlternateValueSetVersionID)

      Set the Variance Classification. This field identifies a categorical set of variances. Classification may be used by applications for presentation and processing functions.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setVarianceClassification

          public void setVarianceClassification(CWE objvarianceClassification)

      Set the Variance Classification. This field identifies a categorical set of variances. Classification may be used by applications for presentation and processing functions.
      Parameters:
        `objvarianceClassification.` -

    - #### addVarianceDescription

          public void addVarianceDescription(java.lang.String strVarianceDescription)

      Set the Variance Description.
      Parameters:
        `strVarianceDescription` - String which to set as Application Error Parameter

    - #### addVarianceDescription

          public void addVarianceDescription(ST objtempVarianceDescription)

      Set the Variance Description.
      Parameters:
        `objtempVarianceDescription` -

    - #### setVarianceDescription

          public void setVarianceDescription(ISingleCollection<ST> objVarianceDescriptionList)

      Set the VarianceDescription list.
      Parameters:
        `objVarianceDescriptionList` - List of VarianceDescription

    - #### setVarianceInstanceID

          public void setVarianceInstanceID(java.lang.String strEntityIdentifier,
                                   java.lang.String strNamespaceId,
                                   java.lang.String strUniversalId,
                                   java.lang.String strUniversalIdType)

      Set the Variance Instance ID.
      Parameters:
        `strEntityIdentifier` - Specifies defined by a hierarchic designator, represented by components 2 through 4. [Reference Section 2.A.33, "HD - hierarchic designator".]
        `strNamespaceId` - Specifies the HL7 identifier for the user-defined table of values for this component. [Refer to User-defined Table 0363 - Assigning authority]
        `strUniversalId` - Specifies string formatted according to the scheme defined by the component, (UID type).
        `strUniversalIdType` - Specifies the interpretation of the second component of the HD.

    - #### setVarianceInstanceID

          public void setVarianceInstanceID(EI objvarianceInstanceID)

      Set the Variance Instance ID.
      Parameters:
        `objvarianceInstanceID` -

    - #### addVarianceOriginator

          public void addVarianceOriginator(java.lang.String strIDNumber,
                                   FN objFamilyName,
                                   java.lang.String strGivenName,
                                   java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof,
                                   java.lang.String strSuffix,
                                   java.lang.String strPrefix,
                                   CWE objSourceTable,
                                   HD objAssigningAuthority,
                                   java.lang.String strNameTypeCode,
                                   java.lang.String strIdentifierCheckDigit,
                                   java.lang.String strCheckDigitScheme,
                                   java.lang.String strIdentifierTypeCode,
                                   HD objAssigningFacility,
                                   java.lang.String strNameRepresentationCode,
                                   CWE objNameContext,
                                   java.lang.String strNameAssemblyOrder,
                                   java.lang.String strEffectiveDate,
                                   java.lang.String strExpirationDate,
                                   java.lang.String strProfessionalSuffix,
                                   CWE objAssigningJurisdiction,
                                   CWE objAssigningAgencyOrDepratment,
                                   java.lang.String strSecurityCheck,
                                   java.lang.String strSecurityCheckScheme)

      Set the Variance Originator. This field contains the originator (person or system) documenting the variance.
      Parameters:
        `strIDNumber` - Refers to the coded ID according to a user-defined table
        `objFamilyName` - Specifies the surname of a person.
        `strGivenName` - Specifies First name.
        `strSecondAndFurtherGivenNamesOrInitialsThereof` - Specifies multiple middle names that may be included by separating them with spaces.
        `strSuffix` - Used to specify a name suffix (e.g., Jr. or III).
        `strPrefix` - Used to specify a name prefix (e.g., Dr.).
        `strSourceTable` - Used as the HL7 identifier for the user-defined table of values for this component. [Refer User-defined Table 0297 - CN ID.]
        `objAssigningAuthority` - Specifies a unique identifier of the system (or organization or agency of department) that creates the data. [Refer User-defined Table 0363 - Assigning authority]
        `strNameTypeCode` - Specifies a code that represents the type of name.
        `strIdentifierCheckDigit` - Specifies part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Specifies the code identifying the check digit scheme employed.[Refer HL7 Table 0061 - Check digit scheme].
        `strIdentifierTypeCode` - Specifies A code corresponding to the type of identifier.[Refer HL7 Table 0203 - Identifier type].
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the person
        `strNameRepresentationCode` - Provides an indication of the representation provided by the data item.
        `objNameContext` - Designates the context in which a name is used. [Refer User-defined Table 0448 ]
        `strNameAssemblyOrder` - Specifies a code that represents the preferred display order of the components of this person name. Suggested values are G,F[Refer table 0444.]
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `strProfessionalSuffix` - Used to specify an abbreviation, or a string of abbreviations, denoting qualifications that support the person's profession, (e.g., licenses).
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepratment` - Specifies the agency or department that assigned the identifier
        `strSecurityCheck` - Specifies the version code that may be assigned to the person identifier
        `strSecurityCheckScheme` - Specifies the check digit scheme.

    - #### addVarianceOriginator

          public void addVarianceOriginator(XCN objtempvarianceOriginator)

      Set the Variance Originator. This field contains the originator (person or system) documenting the variance.
      Parameters:
        `objtempvarianceOriginator` -

    - #### setVarianceOriginator

          public void setVarianceOriginator(ISingleCollection<XCN> objVarianceOriginatorList)

      Set the VarianceOriginator list.
      Parameters:
        `objVarianceOriginatorList` - List of VarianceOriginator

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation chcecks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Throws when Segment Validation fails.